Name:		java-1.8.0-openjfx
Version:	1.8.0.131
Release:	%mkrel 1.b11.5
Summary:	OpenJFX runtime libraries and documentation
Group:		Development/Java
License:	GPLv2 with exceptions
URL:		https://wiki.openjdk.java.net/dashboard.action

Epoch:		1

%global openjfx_version 8u131-b11
%global openjdk8_short_version 1.8.0.131-%mkrel 1.b12.1
# hg clone http://hg.openjdk.java.net/openjfx/8u-dev/rt %{name}-%{version} -r %{openjfx_version}
# tar --exclude ".hg*" -cJf %{name}-%{version}.tar.xz %{name}-%{version}
Source0:	%{name}-%{version}.tar.xz
Patch0:		%{name}-1.8.0.72-mga-correct-copy-file.patch
Patch1:		%{name}-1.8.0.101-set-antlr-timeout.patch
Patch2:		%{name}-1.8.0.101-disable-architecture-verification.patch
Patch3:		%{name}-1.8.0.101-disable-assembler-on-unsupported-archs.patch
Patch4:		%{name}-1.8.0.101-disable-sse2-for-arm.patch
Patch6:		%{name}-1.8.0.131-fix-arm64-build.patch
Patch7:		%{name}-1.8.0.121-fix-arm32-build.patch
Patch8:		%{name}-1.8.0.102-build-flags.patch
Patch9:		%{name}-1.8.0.121-use-system-libs-for-sqlite-and-icu.patch
Patch10:	%{name}-1.8.0.102-use-system-jars.patch

BuildRequires:	java-1.8.0-openjdk-devel
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	gperf
BuildRequires:	pkgconfig
BuildRequires:	pkgconfig(libpng12)
BuildRequires:	libjpeg-devel
BuildRequires:	libxml2-devel
BuildRequires:	libxslt-devel
BuildRequires:	systemd-devel
BuildRequires:	glib2-devel
BuildRequires:	gtk2-devel
BuildRequires:	pkgconfig(xtst)
BuildRequires:	pango-devel
BuildRequires:	freetype-devel
BuildRequires:	alsa-lib-devel
BuildRequires:	qt4-devel
BuildRequires:	pkgconfig(gstreamer-0.10)
BuildRequires:	ffmpeg-devel
BuildRequires:	perl
BuildRequires:	perl-version
BuildRequires:	perl-Digest
BuildRequires:	perl-Digest-MD5
BuildRequires:	coreutils
BuildRequires:	xz
BuildRequires:	binutils
BuildRequires:	libstdc++-static-devel
BuildRequires:	ruby
BuildRequires:	pkgconfig(sqlite3)
BuildRequires:	icu-devel
BuildRequires:	gradle
BuildRequires:	antlr3
BuildRequires:	stringtemplate
BuildRequires:	eclipse-swt
BuildRequires:	cmake
BuildRequires:  hamcrest
Requires:	java-1.8.0-openjdk = %{epoch}:%{openjdk8_short_version}

%description
OpenJFX is an open source, next generation client application platform for
desktop and embedded systems based on JavaSE. It is a collaborative effort
by many individuals and companies with the goal of producing a modern,
efficient, and fully featured toolkit for developing rich client applications.
This is the open source project where we develop JavaFX.

%global openjdk8_version java-1.8.0-openjdk-%{openjdk8_short_version}.%{_arch}
%global openjdk8_install_dir %{buildroot}/usr/lib/jvm/%{openjdk8_version}
%global openjfx_srcdir %{_builddir}/%{name}-%{version}

# There is no need for a debug package (for now)
%global debug_package %{nil}

%ifarch %{ix86}
%global archinstall i386
%endif
%ifarch x86_64
%global archinstall amd64
%endif
%ifarch %{arm}
%global archinstall arm
%endif

%prep
rpm -q %{name} && echo "You need to uninstall the previously built openjfx package before proceeding (this sounds stupid, but it actually makes sense!)" && exit 1
%setup -q

%define gradle_properties %{openjfx_srcdir}/gradle.properties
echo "COMPILE_WEBKIT = true" >> %{gradle_properties}
echo "COMPILE_MEDIA = true" >> %{gradle_properties}
echo "BUILD_JAVADOC = true" >> %{gradle_properties}
echo "BUILD_SRC_ZIP = true" >> %{gradle_properties}

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%ifarch %{arm}
%patch4 -p1
%endif
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

%build
# Copy the ICU and sqlite libraries required by JavaScriptCore
mkdir -p modules/web/build/linux/import/lib/
cp %{_libdir}/libicui18n.so modules/web/build/linux/import/lib/libicui18n.a
cp %{_libdir}/libicuuc.so   modules/web/build/linux/import/lib/libicuuc.a
cp %{_libdir}/libicudata.so modules/web/build/linux/import/lib/libicudata.a
cp %{_libdir}/libsqlite3.so modules/web/build/linux/import/lib/libsqlite3.a

gradle

chmod a-x build/javadoc/javafx/scene/layout/doc-files/borderpane.png
chmod a-x build/javadoc/javafx/scene/paint/doc-files/ImagePattern.png
chmod a-x build/javadoc/javafx/scene/media/doc-files/mediaplayerstatus.png

%install
%global sdkdir build/sdk
mkdir -p build/sdk
chmod -R +x %{sdkdir}
mkdir -p %{openjdk8_install_dir}/{lib,bin,jre/lib/ext}
mkdir -p %{buildroot}/%{_mandir}/man1
mkdir -p %{openjdk8_install_dir}/jre/lib/%{archinstall}

# JDK libraries
install -m644 %{sdkdir}/lib/* %{openjdk8_install_dir}/lib/
install -m755 %{sdkdir}/bin/* %{openjdk8_install_dir}/bin/
install -m644 %{sdkdir}/man/man1/* %{buildroot}/%{_mandir}/man1/

# JRE libraries
install -m644 %{sdkdir}/rt/lib/*.* %{openjdk8_install_dir}/jre/lib/
install -m644 %{sdkdir}/rt/lib/ext/* %{openjdk8_install_dir}/jre/lib/ext/
install -m755 %{sdkdir}/rt/lib/%{archinstall}/* %{openjdk8_install_dir}/jre/lib/%{archinstall}/

xz %{buildroot}/%{_mandir}/man1/*

strip %{openjdk8_install_dir}/jre/lib/%{archinstall}/*.so

%files
%doc build/javadoc
/usr/lib/jvm/%{openjdk8_version}/lib/*
/usr/lib/jvm/%{openjdk8_version}/bin/*
%{_mandir}/man1/*
/usr/lib/jvm/%{openjdk8_version}/jre/lib/*


%changelog
* Sat May 27 2017 neoclust <neoclust> 1:1.8.0.131-1.b11.5.mga6
+ Revision: 1105098
- Fix BuildRequires

* Tue May 02 2017 akien <akien> 1:1.8.0.131-1.b11.4.mga6
+ Revision: 1098291
- Rebuild for ffmpeg 3.3

* Wed Apr 26 2017 ns80 <ns80> 1:1.8.0.131-1.b11.3.mga6
+ Revision: 1097481
- revert last change as it also disables assembler for armv7hl and it causes build failure for both armv5tl and armv7hl

* Tue Apr 25 2017 ns80 <ns80> 1:1.8.0.131-1.b11.2.mga6
+ Revision: 1097327
- try to disable assembler for armv5tl

* Fri Apr 21 2017 ns80 <ns80> 1:1.8.0.131-1.b11.1.mga6
+ Revision: 1096988
- new version u131b11

* Wed Mar 15 2017 mrambo3501 <mrambo3501> 1:1.8.0.121-1.b13.3.mga6
+ Revision: 1092702
- Rebuild for icu-58.2

* Wed Mar 08 2017 akien <akien> 1:1.8.0.121-1.b13.2.mga6
+ Revision: 1089863
- Rebuild for ffmpeg 3.2.4

* Tue Jan 31 2017 ns80 <ns80> 1:1.8.0.121-1.b13.1.mga6
+ Revision: 1084377
- new version u121b13

* Tue Jan 17 2017 ns80 <ns80> 1:1.8.0.111-1.b14.4.mga6
+ Revision: 1082131
- rebuild for new java-1.8.0-openjdk

* Tue Jan 10 2017 ns80 <ns80> 1:1.8.0.111-1.b14.3.mga6
+ Revision: 1080821
- rebuild for new java-1.8.0-openjdk

* Tue Oct 25 2016 ns80 <ns80> 1:1.8.0.111-1.b14.2.mga6
+ Revision: 1063464
- bump release to rebuild

* Fri Oct 21 2016 ns80 <ns80> 1:1.8.0.111-1.b14.1.mga6
+ Revision: 1062880
- new version u111b14

* Mon Oct 03 2016 ns80 <ns80> 1:1.8.0.102-1.b14.4.mga6
+ Revision: 1058253
- add a patch to prevent downloading JArs when building and use the ones provided by Mageia

* Wed Sep 14 2016 ns80 <ns80> 1:1.8.0.102-1.b14.3.mga6
+ Revision: 1052899
- add a patch to use system libs for sqlite and icu

* Tue Sep 13 2016 ns80 <ns80> 1:1.8.0.102-1.b14.2.mga6
+ Revision: 1051850
- add a patch adding Mga build and link flags for ARM

* Sun Sep 11 2016 ns80 <ns80> 1:1.8.0.102-1.b14.1.mga6
+ Revision: 1051560
- new version u102b14

* Fri Sep 09 2016 ns80 <ns80> 1:1.8.0.101-1.b13.3.mga6
+ Revision: 1051157
- add another patch from Debian to allow building on ARM

* Fri Sep 09 2016 ns80 <ns80> 1:1.8.0.101-1.b13.2.mga6
+ Revision: 1051037
- add patches from Debian to allow building on ARM

* Fri Jul 29 2016 ns80 <ns80> 1:1.8.0.101-1.b13.1.mga6
+ Revision: 1043873
- new version u101b13

* Wed Jul 27 2016 tmb <tmb> 1:1.8.0.91-1.b14.4.mga6
+ Revision: 1043739
- rebuild for new java-1.8.0-openjdk

* Wed Jul 06 2016 ns80 <ns80> 1:1.8.0.91-1.b14.3.mga6
+ Revision: 1039082
- rebuild to match java-1.8.0-openjdk

* Fri May 27 2016 ns80 <ns80> 1:1.8.0.91-1.b14.2.mga6
+ Revision: 1018979
- rebuild to match java-1.8.0-openjdk

* Fri Apr 22 2016 ns80 <ns80> 1:1.8.0.91-1.b14.1.mga6
+ Revision: 1005190
- new version u91b14

* Wed Apr 06 2016 ns80 <ns80> 1:1.8.0.76-1.b04.2.mga6
+ Revision: 998989
- rebuild with openjdk 8u77

* Mon Apr 04 2016 ns80 <ns80> 1:1.8.0.76-1.b04.1.mga6
+ Revision: 998373
- new version u76b04

* Fri Feb 12 2016 ns80 <ns80> 1:1.8.0.72-1.b15.1.mga6
+ Revision: 957100
- imported package java-1.8.0-openjfx

